/* A simple server in the internet domain using TCP
   The port number is passed as an argument */
#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <string.h>

void error(char *msg)
{
    perror(msg);
    exit(1);
}

int main(int argc, char *argv[])
{
     int sockfd, newsockfd, portno, clilen;
     char buffer[256];
     struct sockaddr_in serv_addr, cli_addr;
     int n;
     FILE *fp; 

     if (argc < 2) {
         fprintf(stderr,"ERROR, no port provided\n");
         exit(1);
     }
     sockfd = socket(AF_INET, SOCK_STREAM, 0);
     if (sockfd < 0) 
        error("ERROR opening socket");
     bzero((char *) &serv_addr, sizeof(serv_addr));
     portno = atoi(argv[1]);
     serv_addr.sin_family = AF_INET;
     serv_addr.sin_addr.s_addr = INADDR_ANY;
     serv_addr.sin_port = htons(portno);
     if (bind(sockfd, (struct sockaddr *) &serv_addr,
              sizeof(serv_addr)) < 0) 
              error("ERROR on binding");
     listen(sockfd,5);

     while(1) {
         clilen = sizeof(cli_addr);
         newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
         if (newsockfd < 0) 
              error("ERROR on accept");
         bzero(buffer,256);
         n = read(newsockfd,buffer,255);
         if (n < 0) error("ERROR reading from socket");
         printf("Here is the message: %s\n",buffer);
         n = write(newsockfd,"I got your message",18);
         if (n < 0) error("ERROR writing to socket");

         if ( strcmp("start", buffer) == 0) {
             fp = fopen("/Users/andy/test/rec-trigger", "w+");
             fprintf(fp, "0");
             fclose(fp);
             sleep(1);
             fp = fopen("/Users/andy/test/rec-trigger", "w+");
             fprintf(fp, "1");
             fclose(fp);
             

                 }
         if ( strcmp("stop", buffer) == 0) {
                 fp = fopen("/Users/andy/test/rec-trigger", "w+");
                 fprintf(fp, "0");
                 fclose(fp);
                 sleep(60);
                 fp = fopen("/Users/andy/test/rec-trigger", "w+");
                 fprintf(fp, "1");
                 fclose(fp);
                 }



     }
     return 0; 
}
